// window.addEventListener('load', LoginInit, false);
addEvent(window, 'load', LoginInit);

function LoginInit (e) {
	var path = window.location.toString().path();
	if (path.indexOf('login') == -1) 
	{
		window.location = '/login';
		return;
	}
	
	var arr = document.getElementsByTagName('li');
	for (var i=0; i < arr.length; i++) {
		arr[i].addEvent('click', LoginClickedPerson);
		// arr[i].addEventListener('click', LoginClickedPerson, false);
	};
	
	// iPhone
	if (navigator.userAgent.indexOf('iPhone') > -1)
	{
		document.getElementsByTagName('div')[0].id = 'iPhone';
		document.getElementsByTagName('ul')[0].stripe();
		var f = document.getElementsByTagName('form')[0];
		var b = document.createElement("input");
		b.setAttribute("type", "submit");
		b.setAttribute("value", "Submit");
		b.setAttribute("id", "button");
		f.appendChild(b)
	}
}

function LoginClickedPerson (e) {
	var arr = document.getElementsByTagName('li');
	var ul = document.getElementsByTagName('ul')[0];
	for (var i=0; i < arr.length; i++) {
		if (arr[i] != this) arr[i].style.display = 'none';
	};
	document.passform.style.display = 'block';
	document.passform.password.focus();

	// Trim function from http://wonko.com/article/498
	document.passform.name.value = this.childNodes[1].data.replace(/^\s*(\S*(\s+\S+)*)\s*$/, "$1");
	if (navigator.userAgent.indexOf('iPhone') == -1) 
	{
		document.passform.addEvent('keyup', function(e) { if (e.keyCode == 27) LoginReset(); });
	}
	// document.passform.addEventListener('keyup', function (e) { if (e.keyCode == 27) LoginReset(); }, false);
}

function LoginReset (e) {
	var arr = document.getElementsByTagName('li');
	for (var i=0; i < arr.length; i++) {
		arr[i].style.display = 'block';
	};
	document.passform.style.display = 'none';
}

function LoginSubmit (e) {
	var password = document.passform.password.value;
	var name = document.passform.name.value;
	
	var req = new AsyncRequest();
	req.action = LoginHandleResponse;
	req.userdata = escape(name);
	req.fetch('/login/pass/'+encodeURIComponent(name)+'='+hex_md5(password));
}

function LoginHandleResponse (e, request) {
	var sessionId = request.request.responseText;
	
	// DEBUG stuff
	var debug = false;
	if (sessionId.contains("-:-")) {
		debug = true;
		var tmp = sessionId.split("-:-");
		var p = document.createElement("p");
		p.appendChild(document.createTextNode('User ' + tmp[0] + ' expected hash: "' + hex_md5(tmp[1]) + '" (password: ' + document.passform.password.value + ').  Received hash "' + tmp[2] + '" (password: ' + tmp[3] + ').'));
		$('bad').appendChild(p);
		sessionId = '0';
	}
	
	var c = new Cookie();
	if (sessionId != '0')
	{
		c.setValue_forKey_(sessionId, "sessionId");
		c.setValue_forKey_(request.userdata, "name");
		c.save();
		window.location = '/';
		return;
	}
	
	// Bad login
	var bad = document.getElementById('bad');
	bad.style.display = 'block';
	if (!debug)
		window.setTimeout( function(){bad.fadeout();}, 1000);
}